#My controller pathfinding module

from operator import itemgetter #Used for fast tuples in list sorting
#data.sort(key=itemgetter(1))

from collections import deque

def find_path(mapa,start,end,restricted_positions):
    restricted_positions = list(restricted_positions)
    if (end[0],end[1]) in restricted_positions:
        restricted_positions.remove((end[0],end[1]))
    #Nodes to be visited and visited nodes have to have format (x,y,distance_from_start,heuristics_value)
    start_node = (start[0],start[1],0,heuristic_function(0,start[0],start[1],end[0],end[1]))
    visited = {(start_node[0],start_node[1]):""}
    processing_queue = [start_node]

    while processing_queue:
        processing_queue.sort(key=itemgetter(3))
        processing_queue.reverse()
        current_node = processing_queue.pop()

        if current_node[0] == end[0] and current_node[1] == end[1]:
            break

        for node in get_next_nodes(current_node,mapa,restricted_positions):
            if not node in visited:
                visited[node] = (current_node[0],current_node[1])
                new_node = (node[0],node[1],current_node[2]+1,heuristic_function(current_node[2]+1,node[0],node[1],end[0],end[1]))
                processing_queue.append(new_node)

    if not processing_queue: #It wasn't possible to find the end node
        return deque(["It wasn't possible to find the end node"])

    path = deque()
    current_node = (current_node[0],current_node[1])

    while current_node:
        path.append(current_node)
        current_node = visited[current_node]

    path.reverse()
    return path

def get_next_nodes(node,mapa,restricted_positions):
    next_nodes = []
    if check_node((node[0]+1,node[1]),mapa,restricted_positions):
        next_nodes.append((node[0]+1,node[1]))
    if check_node((node[0]-1,node[1]),mapa,restricted_positions):
        next_nodes.append((node[0]-1,node[1]))
    if check_node((node[0],node[1]+1),mapa,restricted_positions):
        next_nodes.append((node[0],node[1]+1))
    if check_node((node[0],node[1]-1),mapa,restricted_positions):
        next_nodes.append((node[0],node[1]-1))

    return next_nodes

def check_node(node,mapa,restricted_positions):
    if (node[0] >= 0 and node[0] < len(mapa) and node[1] >= 0 and node[1] < len(mapa[0]) and
        mapa[node[0]][node[1]] and not (node[0],node[1]) in restricted_positions):
        return True
    return False

def heuristic_function(distance_from_start,node_x,node_y,end_x,end_y):
    value = distance_from_start + (abs(node_x-end_x)+abs(node_y-end_y))
    return value
    
    
