#Map loading module - very complicated
#Map are not just terrain maps, they are now folders containing ore map, units and buildings and terrain map
import os

def load_map(map_folder_path):
    #Creates path to map files
    terrain_map_path = os.path.join(map_folder_path,"terrain.txt")
    unit_file_path = os.path.join(map_folder_path,"units.txt")
    building_file_path = os.path.join(map_folder_path,"buildings.txt")
    ore_file_path = os.path.join(map_folder_path,"ores.txt")
    
    #Loads the map files
    terrain_map = load_terrain_map(terrain_map_path)
    unit_file = open(unit_file_path,"r")
    building_file = open(building_file_path,"r")
    ore_file = open(ore_file_path,"r")

    return [terrain_map, unit_file, building_file, ore_file]

def load_terrain_map(terrain_map_file_path):
    #Loads terrain map - terrain map must be rectangle made of positive integers up to 10 (0...9)
    terrain_map = [] #Variable storing loaded terrain_map

    terrain_map_file = open(terrain_map_file_path,"r")

    for line in terrain_map_file:
        if not "#" == line[0]: #Supports comments if they begin with # at beginning of line
            if "\n" in line:
                line = line[:-1]
            map_line = [int(i) for i in list(line)]
            terrain_map.append(map_line)

    terrain_map_file.close()

    return terrain_map

def finalize_loading(unit_file,building_file,ore_file,game_manager): #Writes data from unit_file, building_file and ore_file into game_manager (teams_manager?)
    #Writes unit data into game manager
    for line in unit_file:
        if not "#" == line[0]: #Supports comments if they begin with # at beginning of line
            if "\n" in line:
                line = line[:-1]
            line = line.split(";") #First splits the line on ; , each segment belongs to one unit
            for segment in line:
                if segment:
                    segment = segment.split(":") #Splits the segment into 4 segments on : , and it goes then team_number, x_position, y_position, unit_type
                    game_manager.create_unit(int(segment[0]),int(segment[1]),int(segment[2]),segment[3])

    #Writes building data into game manager
    for line in building_file:
        if not "#" == line[0]: #Supports comments if they begin with # at beginning of line
            if "\n" in line:
                line = line[:-1]
            line = line.split(";") #First splits the line on ; , each segment belongs to one building
            for segment in line:
                if segment:
                    segment = segment.split(":") #Splits the segment into 4 segments on : , and it goes then team_number, x_position, y_position, building_type
                    game_manager.create_building(int(segment[0]),int(segment[1]),int(segment[2]),segment[3])

    #Writes ore data into game_manager
    for line in ore_file:
        if not "#" == line[0]: #Supports comments if they begin with # at beginning of line
            if "\n" in line:
                line = line[:-1]
            line = line.split(";") #First splits the line on ; , each segment belongs to one file
            for segment in line:
                if segment:
                    segment = segment.split(":") #Splits the segment into 4 segments on : , and it goes then ore_name, x_position, y_position, ore_amount
                    game_manager.ore_manager.create_ore(segment[0],int(segment[1]),int(segment[2]),int(segment[3]))







