#Module for managing ore positions and ore types

from simple_modules import moduleFilePathFormer #Necessary to access files with unit and building types in other directories

class OreManager():
    def __init__(self,drawing_engine):
        self.ore_types = {"no":(("",""))} #Contains ore types
        self.ores = {} #Contains ore in pairs position:(ore,amount)

        self.drawing_engine = drawing_engine #Used for drawing ores
        
        self.filePathFormer = moduleFilePathFormer.FilePathFormer("Game_folder")

        self.load_ore_types()
        
    def load_ore_types(self):
        file = open(self.filePathFormer.create_path_to_file(["Ores","ore_types.txt"]),"r")
        for line in file:
            if not line[0] == "#":
                if "\n" in line: #Removes line ending
                    line = line[:-1]
                line = line.split(":")
                #Loads useable mining tools
                self.ore_types[line[0]] = tuple(line[1].split(","))

        file.close()

    def draw_all(self): #Draws all ores on the screen
        for position, ore_and_ore_amount in self.ores.items():
            self.drawing_engine.draw_object(ore_and_ore_amount[0],position[0],position[1])

    def update(self):
        ore_positions_for_deletion = []
        for position, ore_and_ore_amount in self.ores.items(): #Removes mined out ores
            if not ore_and_ore_amount[1] > 0:
                ore_positions_for_deletion.append(position)
                
        for position in ore_positions_for_deletion:
            del self.ores[position]

    def create_ore(self,ore,x,y,ore_amount=50):
        self.ores[(x,y)]=(ore,ore_amount)
