#Module for loading and handling recipes

from simple_modules import moduleFilePathFormer #Necessary to access files with recipes in other directories

from collections import defaultdict

class RecipeManager():
    def __init__(self):
        self.recipes = defaultdict(lambda:[])
        self.resource_recipes = defaultdict(lambda:[])

        self.filePathFormer = moduleFilePathFormer.FilePathFormer("Game_folder")

        self.load_recipes()
        self.load_resource_recipes()

    def load_recipes(self):
        file = open(self.filePathFormer.create_path_to_file(["RnR","recipes.txt"]),"r")
        for line in file:
            if not line[0] == "#":
                if "\n" in line: #Removes line ending
                    line = line[:-1]
                line = line.split(":")
                #Loads tools (usable), resource names and resources required for the recipe
                self.recipes[line[0]].append(tuple([line[1].split(","),line[2].split(","),line[3].split(","),int(line[4])]))

        file.close()

    def load_resource_recipes(self):
        file = open(self.filePathFormer.create_path_to_file(["RnR","resource_recipes.txt"]),"r")
        for line in file:
            if not line[0] == "#":
                if "\n" in line: #Removes line ending
                    line = line[:-1]
                line = line.split(":")
                #Loads tools (usable), resource names, resources and amount created required for the recipe
                resource_recipe = [line[1].split(","),line[2].split(","),line[3].split(","),int(line[4]),int(line[5])]
                for i in range(len(resource_recipe[2])): #Converts required amount of resources to integers
                    if not resource_recipe[2][i]: #If it is empty string, convert to 0
                        resource_recipe[2][i] = 0
                    resource_recipe[2][i] = int(resource_recipe[2][i])
                
                self.resource_recipes[line[0]].append(tuple(resource_recipe))

        file.close()
